
#define CDROM_READ_TOC_EX_FORMAT_TOC      0x00
#define CDROM_READ_TOC_EX_FORMAT_SESSION  0x01
#define CDROM_READ_TOC_EX_FORMAT_FULL_TOC 0x02
#define CDROM_READ_TOC_EX_FORMAT_PMA      0x03
#define CDROM_READ_TOC_EX_FORMAT_ATIP     0x04
#define CDROM_READ_TOC_EX_FORMAT_CDTEXT   0x05

typedef struct _CDROM_TOC_CD_TEXT_DATA_BLOCK {  
    UCHAR  PackType;  
    UCHAR  TrackNumber:7;  
    UCHAR  ExtensionFlag:1;  // should be zero apparently
    UCHAR  SequenceNumber;  
    UCHAR  CharacterPosition:4;  
    UCHAR  BlockNumber:3;  
    UCHAR  Unicode:1;  
    union {    
    UCHAR  Text[12];    
    WCHAR  WText[6];  
    };  
    UCHAR  CRC[2];
} CDROM_TOC_CD_TEXT_DATA_BLOCK, *PCDROM_TOC_CD_TEXT_DATA_BLOCK;


typedef struct _CDROM_TOC_CD_TEXT_DATA {

    UCHAR Length[2];  // add two bytes for this field
    UCHAR Reserved1;
    UCHAR Reserved2;
    
    
    CDROM_TOC_CD_TEXT_DATA_BLOCK Descriptors[256];

} CDROM_TOC_CD_TEXT_DATA, *PCDROM_TOC_CD_TEXT_DATA;

#define CDROM_CD_TEXT_PACK_ALBUM_NAME 0x80
#define CDROM_CD_TEXT_PACK_PERFORMER  0x81
#define CDROM_CD_TEXT_PACK_SONGWRITER 0x82
#define CDROM_CD_TEXT_PACK_COMPOSER   0x83
#define CDROM_CD_TEXT_PACK_ARRANGER   0x84
#define CDROM_CD_TEXT_PACK_MESSAGES   0x85
#define CDROM_CD_TEXT_PACK_DISC_ID    0x86
#define CDROM_CD_TEXT_PACK_GENRE      0x87
#define CDROM_CD_TEXT_PACK_TOC_INFO   0x88
#define CDROM_CD_TEXT_PACK_TOC_INFO2  0x89
// 0x8a - 0x8d  reserved
#define CDROM_CD_TEXT_PACK_UPC_EAN    0x8e
#define CDROM_CD_TEXT_PACK_SIZE_INFO  0x8f

const char* Genres[] = { "" ,"Blues", "Classic Rock", "Country", "Dance", 
      "Disco", "Funk", "Grunge", "Hip Hop", 
      "Jazz", "Metal", "New Age", "Oldies", 
      "Other", "Pop", "R And B", "Rap", 
      "Reggae", "Rock", "Techno", "Industrial", 
      "Alternative", "Ska", "Death Metal", "Pranks", 
      "Soundtrack", "Euro Techno", "Ambient", "Trip Hop", 
      "Vocal", "Jazz And Funk", "Fusion", "Trance", 
      "Classical", "Instrumental", "Acid", "House", 
      "Game", "Sound Clip", "Gospel", "Noise", 
      "Altenative Rock", "Bass", "Soul", "Punk", 
      "Space", "Meditative", "Instrumental Pop", "Instrumental Rock", 
      "Ethnic", "Gothic", "Darkwave", "Techno-Industrial", 
      "Electronic", "Pop Folk", "Eurodance", "Dream", 
      "Southern Rock", "Comedy", "Cult", "Gangsta Rap", 
      "Top 40", "Christian Rap", "Pop Funk", "Jungle", 
      "Native American", "Cabaret", "New Wave", "Psychedelic", 
      "Rave", "Showtunes", "Trailer", "LoFi", 
      "Tribal", "Acid Punk", "Acid Jazz", "Polka", 
      "Retro", "Musical", "Rock And Roll", "Hard Rock", 
      "Folk", "Folk Rock", "National Folk", "Swing", 
      "Fast-Fusion", "Bebop", "Latin", "Revival", 
      "Celtic", "Bluegrass", "Avantgarde", "Gothic Rock", 
      "Progressive Rock", "Psychedelic Rock", "Symphonic Rock", "Slow Rock", 
      "Big Band", "Chorus", "Easy Listening", "Acoustic", 
      "Humour", "Speech", "Chanson", "Opera", 
      "Chamber Music", "Sonata", "Symphony", "Booty Bass", 
      "Primus", "Porn Groove", "Satire", "Slow Jam", 
      "Club", "Tango", "Samba", "Folklore", 
      "Ballad", "Power Ballad", "Rhythmic Soul", "Freestyle", 
      "Duet", "Punk Rock", "Drum Solo", "A Cappella", 
      "Euro House", "Dance Hall", "Goa", "Drum And Bass", 
      "Club House", "Hardcore", "Terror", "Indie", 
      "BritPop", "Negerpunk", "Polsk Punk", "Beat", 
      "Christian Gangsta Rap", "Heavy Metal", "Black Metal", "Crossover", 
      "Contemporary Christian", "Christian Rock", "Merengue", 
      "Salsa", "Thrash Metal"};

